//+------------------------------------------------------------------+
//| Accelerator_TRO_MODIFIED_VERSION                 Accelerator.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
//| _TRO_MODIFIED_VERSION                                  |
//| MODIFIED BY AVERY T. HORTON, JR. AKA THERUMPLEDONE@GMAIL.COM     |
//| I am NOT the ORIGINAL author 
//  and I am not claiming authorship of this indicator. 
//  All I did was modify it. I hope you find my modifications useful.|
//|                                                                  |
//+------------------------------------------------------------------+
 
#property  copyright "Copyright  2005, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 7
#property  indicator_color1  Black
#property  indicator_color2  Green
#property  indicator_color3  Red
#property  indicator_color4  Magenta

#property  indicator_color6  Maroon
#property  indicator_color7  Lime

#property  indicator_width2  3
#property  indicator_width3  3
#property  indicator_width6  3
#property  indicator_width7  3


//---- indicator buffers
double     ExtBuffer0[];
double     ExtBuffer1[];
double     ExtBuffer2[];
double     ExtBuffer3[];
double     ExtBuffer4[];
double     ExtBuffer5[];
double     ExtBuffer6[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

//---- drawing settings
   SetIndexStyle(0,DRAW_NONE);

   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   
   SetIndexStyle(3,DRAW_NONE);  
   SetIndexStyle(4,DRAW_NONE);      
   
   SetIndexStyle(5,DRAW_HISTOGRAM);
   SetIndexStyle(6,DRAW_HISTOGRAM);   
   
   IndicatorDigits(Digits+2);
   SetIndexDrawBegin(0,38);
   SetIndexDrawBegin(1,38);
   SetIndexDrawBegin(2,38);
   SetIndexDrawBegin(5,38);
   SetIndexDrawBegin(6,38);

   SetIndexBuffer(0,ExtBuffer0);
   SetIndexBuffer(1,ExtBuffer1);
   SetIndexBuffer(2,ExtBuffer2);
   SetIndexBuffer(3,ExtBuffer3);
   SetIndexBuffer(4,ExtBuffer4);
   SetIndexBuffer(5,ExtBuffer5);
   SetIndexBuffer(6,ExtBuffer6);   
   
   SetIndexEmptyValue(1, EMPTY_VALUE ) ;
   SetIndexEmptyValue(2, EMPTY_VALUE ) ;
   SetIndexEmptyValue(5, EMPTY_VALUE ) ;   
   SetIndexEmptyValue(6, EMPTY_VALUE ) ;
   
//---- name for DataWindow and indicator subwindow label

   IndicatorShortName("AC TRO Modified");

      
   
   
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Accelerator/Decelerator Oscillator                               |
//+------------------------------------------------------------------+
int start()
  {
   int    limit;
   int    counted_bars=IndicatorCounted();
   double prev,current;
   //---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   //---- macd counted in the 1-st additional buffer
   for(int i=0; i<limit; i++)
      ExtBuffer3[i]=iMA(NULL,0,5,0,MODE_SMA,PRICE_MEDIAN,i)-iMA(NULL,0,34,0,MODE_SMA,PRICE_MEDIAN,i);
   //---- signal line counted in the 2-nd additional buffer
   for(i=0; i<limit; i++)
      ExtBuffer4[i]=iMAOnArray(ExtBuffer3,Bars,5,0,MODE_SMA,i);
   //---- dispatch values between 2 buffers
   bool up=true;
   for(i=limit-1; i>=0; i--)
     {
      current=ExtBuffer3[i]-ExtBuffer4[i];
      prev=ExtBuffer3[i+1]-ExtBuffer4[i+1];
      
      if(current>=0) {up=true;} else { up=false; }


               ExtBuffer6[i]=EMPTY_VALUE;
               ExtBuffer5[i]=EMPTY_VALUE;        
               ExtBuffer2[i]=EMPTY_VALUE;
               ExtBuffer1[i]=EMPTY_VALUE;
      
//      if(current<0) up=false;
      if(!up)
        {
        if(current <= prev) { ExtBuffer2[i]=current; } else {ExtBuffer5[i]=current;  }    
        }
      else
        {
        if(current <= prev) { ExtBuffer1[i]=current; } else { ExtBuffer6[i]=current;}          
        }
        
       ExtBuffer0[i]=current;
     }
   //---- done
   return(0);
  }
//+------------------------------------------------------------------+

