//+------------------------------------------------------------------+
//|                       tro_pivot_dots                             |
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFT AND DONATIONS ACCEPTED                                    | 
//|                                                                  |  
//|    http://docs.mql4.com/constants/wingdings                      |                                         |
//+------------------------------------------------------------------+

#property copyright "Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne"
#property link      "therumpledone@gmail.com"

#property indicator_chart_window 
#property indicator_buffers 2

//#property indicator_color1 Yellow 
//#property indicator_color2 Brown

//---- For the small screens
//extern string    Display_infos         = "=== If true, displayed on the chart ===";
//extern bool      display_on_chart      =  true ;  // If true, the open trade analysis, daily pivots and daily range will be displayed on the chart window

// indicators parameters

extern bool iPlotChart = true ;
extern bool iPlotGauge = false ;

extern bool   Show.PriceBox  = true ;
extern int    myBoxWidth  = 1;
 
extern int LocalTimeZone= 0;
extern int DestTimeZone= 0;

//extern int myPeriod  = 1440 ;
extern int myOffset  = 1 ; 
extern int myChartY = 1 ;

extern int myStyle1  = 2 ;
extern int myStyle2  = 2 ;


extern int myWingDing1  = 115 ;
extern int myWingDing2  = 115 ;


extern color myColor1 =Yellow ;
extern color myColor2 =Brown;
 
//---- buffers

double P1Buffer[];
double P2Buffer[];
double P3Buffer[];
double P4Buffer[];
double P5Buffer[];
double P6Buffer[];
double P7Buffer[];

double yesterday_high=0;
double yesterday_open=0;
double yesterday_low=0;
double yesterday_close=0;
double today_open=0;
double today_high=0;
double today_low=0;


string tPIVOT0 = "PIVOT_0" ;
string tPIVOT1 = "PIVOT_1" ;



//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- name for indicator window

   string short_name=" ";
   IndicatorShortName(short_name);
   SetIndexBuffer(0, P1Buffer);
   SetIndexBuffer(1, P2Buffer);

//----

SetIndexArrow(0, myWingDing1); 
SetIndexArrow(1, myWingDing2); 



   SetIndexStyle(0, DRAW_ARROW, myStyle1, 1, myColor1 );
   SetIndexStyle(1, DRAW_ARROW, myStyle2, 1, myColor2 );   
  
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   
   ObjectDelete("PIV");
   ObjectDelete("line5PIV");
   ObjectDelete("X01_LabelPIV");
   ObjectDelete("X01_ValuePIV");
   ObjectDelete("X02_LabelPIV");
   ObjectDelete("X02_ValuePIV");
   ObjectDelete("X03_LabelPIV");
   ObjectDelete("X03_ValuePIV");
   ObjectDelete("X04_LabelPIV");
   ObjectDelete("X04_ValuePIV");
   ObjectDelete("X05_LabelPIV");
   ObjectDelete("X05_ValuePIV");
   ObjectDelete("X06_LabelPIV");
   ObjectDelete("X06_ValuePIV");
   ObjectDelete("X07_LabelPIV");
   ObjectDelete("X07_ValuePIV");
   ObjectDelete(tPIVOT0);
   ObjectDelete(tPIVOT1);
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

  
   int i, dayi, counted_bars = IndicatorCounted();
//---- check for possible errors
   if(counted_bars < 0) 
       return(-1);
//---- last counted bar will be recounted
   if(counted_bars > 0) 
       counted_bars--;  
   int limit = Bars - counted_bars;
//----   
   for(i = limit - 1; i >= 0; i--)
     {
		
   double X01 = (iHigh(NULL,0,i) + iLow(NULL,0,i) + iClose(NULL,0,i)) * 0.333333 ;  
   double X02 = (iHigh(NULL,0,i+1) + iLow(NULL,0,i+1) + iClose(NULL,0,i+1)) * 0.333333 ;  
   double X03 = 0 ;
   double X04 = 0 ;	
   double X05 = 0 ;	
   double X06 = 0 ;
	double X07 = 0 ;

   X01 = NormalizeDouble(X01, Digits) ;
   X02 = NormalizeDouble(X02, Digits) ; 
   
if ( iPlotChart ) { 
	
	P1Buffer[i] = X01 ;
	P2Buffer[i] = X02 ;
   P3Buffer[i] = X03 ;
	P4Buffer[i] = X04 ;
	P5Buffer[i] = X05 ;
   P6Buffer[i] = X06 ;
   P7Buffer[i] = X07 ;


  

} // iPlotChart

} // FOR 

if(Show.PriceBox)  
{ 
  if (ObjectFind(tPIVOT0) != 0)
      {
          ObjectCreate(tPIVOT0,OBJ_ARROW,0,Time[0],X01);
          ObjectSet(tPIVOT0,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tPIVOT0,OBJPROP_WIDTH,myBoxWidth);  
          ObjectSet(tPIVOT0,OBJPROP_COLOR,myColor1);  
      } 
      else
      {
         ObjectMove(tPIVOT0,0,Time[0],X01);
      }
 

    
    if (ObjectFind(tPIVOT1) != 0)
      {
          ObjectCreate(tPIVOT1,OBJ_ARROW,0,Time[0],X02);
          ObjectSet(tPIVOT1,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tPIVOT1,OBJPROP_WIDTH,myBoxWidth);            
          ObjectSet(tPIVOT1,OBJPROP_COLOR,myColor2);  
      } 
      else
      {
         ObjectMove(tPIVOT1,0,Time[0],X02);
      }


} // 

if ( iPlotGauge ) {  
    
string StrX01 = "PIV" ; 
string StrX02 = "Prev" ; 
string StrX03 = "-XO3" ; 
string StrX04 = "-XO4" ; 
string StrX05 = "-XO5" ; 
string StrX06 = "-XO6" ; 
string StrX07 = "-XO7" ; 

   color color_PIV_1=Orchid;
                
   color color_X01=Red;
   color color_X02=Red;
   color color_X03=Red;
   color color_X04=Red;
   color color_X05=Red;
   color color_X06=Red;
   color color_X07=Red;  
   	
	if( Close[0] < X01) { color_X01=Lime; } 
	if( Close[0] < X02) { color_X02=Lime; } 	
	if( Close[0] < X03) { color_X03=Lime; } 
	if( Close[0] < X04) { color_X04=Lime; } 
	if( Close[0] < X05) { color_X05=Lime; } 
	if( Close[0] < X06) { color_X06=Lime; }		
//	if( Close[0] < X07) { color_X07=Lime; }		
		
	


int sPeriod= Period();

//if (myPeriod != NULL){ sPeriod= myPeriod ;}
       	
//---- Set labels

   int WindowToUse;
   int Corner_line, Xdist_line;
   int Corner_text, Corner_ValuePIV, Xdist_text, Xdist_ValuePIV;
   int Ydist_line5;
   int Corner_pivots, Xdist_pivots, Ydist_pivots;
   int Ydist_X01, Ydist_X02, Ydist_X03, Ydist_X04, Ydist_X05, Ydist_X06, Ydist_X07;
   int YdistInc ;
   
    WindowToUse =  0;
    Corner_line = 1;
    Corner_text = 1; 
    Corner_ValuePIV = 1;
    Xdist_line = 21; 
    Xdist_text = 93; 
    Xdist_ValuePIV = 23;
    Corner_pivots = 1; 
    Xdist_pivots = 21; 
    
    Ydist_pivots = myChartY;  
    Ydist_line5 = 
    Ydist_pivots + 11; 
    YdistInc = 15 ;
    Ydist_X01 = Ydist_pivots + 25; 
    Ydist_X02 = Ydist_X01 + YdistInc; 
    Ydist_X03 = Ydist_X01 + YdistInc*2; 
    Ydist_X04 = Ydist_X01 + YdistInc*3; 
    Ydist_X05 = Ydist_X01 + YdistInc*4; 
    Ydist_X06 = Ydist_X01 + YdistInc*5; 
    Ydist_X07 = Ydist_X01 + YdistInc*6;

   ObjectCreate("PIV", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("PIV",sPeriod + " PIV ",9, "Verdana", color_PIV_1);
   ObjectSet("PIV", OBJPROP_CORNER, Corner_pivots);
   ObjectSet("PIV", OBJPROP_XDISTANCE, Xdist_pivots);
   ObjectSet("PIV", OBJPROP_YDISTANCE, Ydist_pivots);
   
   ObjectCreate("line5PIV", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("line5PIV","---------------------",7, "Verdana", color_PIV_1);
   ObjectSet("line5PIV", OBJPROP_CORNER, Corner_line);
   ObjectSet("line5PIV", OBJPROP_XDISTANCE, Xdist_line);
   ObjectSet("line5PIV", OBJPROP_YDISTANCE, Ydist_line5);
   
   ObjectCreate("X01_LabelPIV", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("X01_LabelPIV",StrX01,9, "Verdana", myColor1);
   ObjectSet("X01_LabelPIV", OBJPROP_CORNER, Corner_text);
   ObjectSet("X01_LabelPIV", OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet("X01_LabelPIV", OBJPROP_YDISTANCE, Ydist_X01);
   
   ObjectCreate("X01_ValuePIV", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("X01_ValuePIV"," "+DoubleToStr(X01,Digits),9, "Verdana", color_X01);
   ObjectSet("X01_ValuePIV", OBJPROP_CORNER, Corner_ValuePIV);
   ObjectSet("X01_ValuePIV", OBJPROP_XDISTANCE, Xdist_ValuePIV);
   ObjectSet("X01_ValuePIV", OBJPROP_YDISTANCE, Ydist_X01);
   
   ObjectCreate("X02_LabelPIV", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("X02_LabelPIV",StrX02,9, "Verdana", myColor2);
   ObjectSet("X02_LabelPIV", OBJPROP_CORNER, Corner_text);
   ObjectSet("X02_LabelPIV", OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet("X02_LabelPIV", OBJPROP_YDISTANCE, Ydist_X02);
   
   ObjectCreate("X02_ValuePIV", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("X02_ValuePIV"," "+DoubleToStr(X02,Digits),9, "Verdana", color_X02);
   ObjectSet("X02_ValuePIV", OBJPROP_CORNER, Corner_ValuePIV);
   ObjectSet("X02_ValuePIV", OBJPROP_XDISTANCE, Xdist_ValuePIV);
   ObjectSet("X02_ValuePIV", OBJPROP_YDISTANCE, Ydist_X02);
/*
   ObjectCreate("X03_LabelPIV", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("X03_LabelPIV",StrX03,9, "Verdana", myColor3 );
   ObjectSet("X03_LabelPIV", OBJPROP_CORNER, Corner_text);
   ObjectSet("X03_LabelPIV", OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet("X03_LabelPIV", OBJPROP_YDISTANCE, Ydist_X03);
   
   ObjectCreate("X03_ValuePIV", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("X03_ValuePIV"," "+DoubleToStr(X03,dig),9, "Verdana", color_X03);
   ObjectSet("X03_ValuePIV", OBJPROP_CORNER, Corner_ValuePIV);
   ObjectSet("X03_ValuePIV", OBJPROP_XDISTANCE, Xdist_ValuePIV);
   ObjectSet("X03_ValuePIV", OBJPROP_YDISTANCE, Ydist_X03);

   ObjectCreate("X04_LabelPIV", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("X04_LabelPIV",StrX04,9, "Verdana", myColor4 );
   ObjectSet("X04_LabelPIV", OBJPROP_CORNER, Corner_text);
   ObjectSet("X04_LabelPIV", OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet("X04_LabelPIV", OBJPROP_YDISTANCE, Ydist_X04);
   
   ObjectCreate("X04_ValuePIV", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("X04_ValuePIV"," "+DoubleToStr(X04,dig),9, "Verdana", color_X04);
   ObjectSet("X04_ValuePIV", OBJPROP_CORNER, Corner_ValuePIV);
   ObjectSet("X04_ValuePIV", OBJPROP_XDISTANCE, Xdist_ValuePIV);
   ObjectSet("X04_ValuePIV", OBJPROP_YDISTANCE, Ydist_X04);

   ObjectCreate("X05_LabelPIV", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("X05_LabelPIV",StrX05,9, "Verdana", myColor5 );
   ObjectSet("X05_LabelPIV", OBJPROP_CORNER, Corner_text);
   ObjectSet("X05_LabelPIV", OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet("X05_LabelPIV", OBJPROP_YDISTANCE, Ydist_X05);
   
   ObjectCreate("X05_ValuePIV", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("X05_ValuePIV"," "+DoubleToStr(X05,dig),9, "Verdana", color_X05);
   ObjectSet("X05_ValuePIV", OBJPROP_CORNER, Corner_ValuePIV);
   ObjectSet("X05_ValuePIV", OBJPROP_XDISTANCE, Xdist_ValuePIV);
   ObjectSet("X05_ValuePIV", OBJPROP_YDISTANCE, Ydist_X05);
    
   ObjectCreate("X06_LabelPIV", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("X06_LabelPIV",StrX06,9, "Verdana", myColor6 );
   ObjectSet("X06_LabelPIV", OBJPROP_CORNER, Corner_text);
   ObjectSet("X06_LabelPIV", OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet("X06_LabelPIV", OBJPROP_YDISTANCE, Ydist_X06);
   
   ObjectCreate("X06_ValuePIV", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("X06_ValuePIV"," "+DoubleToStr(X06,dig),9, "Verdana", color_X06);
   ObjectSet("X06_ValuePIV", OBJPROP_CORNER, Corner_ValuePIV);
   ObjectSet("X06_ValuePIV", OBJPROP_XDISTANCE, Xdist_ValuePIV);
   ObjectSet("X06_ValuePIV", OBJPROP_YDISTANCE, Ydist_X06);
   
   ObjectCreate("X07_LabelPIV", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("X07_LabelPIV",StrX07,9, "Verdana", myColor7 );
   ObjectSet("X07_LabelPIV", OBJPROP_CORNER, Corner_text);
   ObjectSet("X07_LabelPIV", OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet("X07_LabelPIV", OBJPROP_YDISTANCE, Ydist_X07);
   
   ObjectCreate("X07_ValuePIV", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("X07_ValuePIV"," "+DoubleToStr(X07,dig),9, "Verdana", color_X07);
   ObjectSet("X07_ValuePIV", OBJPROP_CORNER, Corner_ValuePIV);
   ObjectSet("X07_ValuePIV", OBJPROP_XDISTANCE, Xdist_ValuePIV);
   ObjectSet("X07_ValuePIV", OBJPROP_YDISTANCE, Ydist_X07);
*/
} // iPlotGauge
    
   return(0);
  }


